#include "debugger.h"
#define	BUFSIZE		20480
#define VARLEN            256
#ifndef INADDR_NONE
#define INADDR_NONE 0xffffffff
#endif  /* INADDR_NONE */
extern int  errno;
extern char *sys_errlist[];

void send_instrument_command(int subcommand,int nextModule,
			char *funcName, char *hpfStmtList)
{
  int buflen;
  
  /* Send INSTRUMENT+nextModule+funcName+hpfStmtList+pid 
     to HPFFrontEnd Server */
  send_int(ManagerSock,SAGECOMMAND);
  buflen=packed_string_length(funcName)+packed_string_length(hpfStmtList)+12; 
  send_int(ManagerSock,buflen);   
  send_int(ManagerSock,subcommand);
  send_int(ManagerSock,nextModule);
  send_String(ManagerSock,funcName);
  send_String(ManagerSock,hpfStmtList);
  send_int(ManagerSock,ME);
  
  printf("ME:%d-DARP client sents SAGECOMMAND : %d \n",
	 ME,subcommand );
}


int GetInstrumentedCode(int nextModule,char *funcName,char *usedVars[],
		int *numOfVars,char *userHpfStmts)
{
  FILE *fTemp;
  char filename[VARLEN],fname[VARLEN];
  char instrumentedCode[BUFSIZE];
  int k,nVars,*rs,errcode;
  int pid,status;
  char *userDir;
  char interpSoFile[MAXVARLEN];

  /* receive error code */
  recv_int(ManagerSock,&errcode);
  /* receive number of parameters */
  recv_int(ManagerSock,&nVars);
  /* receive parameters */
  for(k=0;k<nVars;k++){
    usedVars[k] = (char *)malloc(sizeof(char)*VARLEN);
    recv_String(ManagerSock,usedVars[k]);
  }
   
  /* receive original user hpf statements */
  recv_String(ManagerSock,userHpfStmts);
  /*receive the instrumented code */
  recv_String(ManagerSock,instrumentedCode);
  if (DEBUG)
      fprintf(fpout,
	  "DARP CLIENT:I received instrumented code : %s\n",instrumentedCode);
    
  /* write received instrumented code to file */
  userDir = getenv("USERDIR");
  sprintf(interpSoFile,"%sfoos_%d.f",userDir,ME);

  fTemp = fopen(interpSoFile,"w");
  fprintf(fTemp,"%s", instrumentedCode);
  fclose(fTemp);
  /* set Number of used variabels which will be parameters */
  *numOfVars = nVars;
  
  return errcode;
  
}


/*------------------------------------------------------------------------
 * connectsock - allocate & connect a socket using TCP or UDP
 *------------------------------------------------------------------------
 */
int
connectsock( host, service, protocol )
char    *host;      /* name of host to which connection is desired  */
char    *service;   /* service associated with the desired port */
char    *protocol;  /* name of protocol to use ("tcp" or "udp") */
{
    struct hostent  *phe;   /* pointer to host information entry    */
    struct servent  *pse;   /* pointer to service information entry */
    struct protoent *ppe;   /* pointer to protocol information entry*/
    struct sockaddr_in sin; /* an Internet endpoint address     */
    int s, type;    /* socket descriptor and socket type    */
        
 
    printf("I am trying to connect to %s with port:%s\n",host,service);
      
    bzero((char *)&sin, sizeof(sin));
    sin.sin_family = AF_INET;
 
    /* Map service name to port number */
    if ( pse = getservbyname(service, protocol) )
        sin.sin_port = pse->s_port;
    else if ( (sin.sin_port = htons((u_short)atoi(service))) == 0 )
        errexit("can't get \"%s\" service entry\n", service);
 
    /* Map host name to IP address, allowing for dotted decimal */
    if ( phe = gethostbyname(host) )
 
        bcopy(phe->h_addr, (char *)&sin.sin_addr, phe->h_length);
    else if ( (sin.sin_addr.s_addr = inet_addr(host)) == INADDR_NONE )
        errexit("can't get \"%s\" host entry\n", host);
 
    /* Map protocol name to protocol number */
    if ( (ppe = getprotobyname(protocol)) == 0)
        errexit("can't get \"%s\" protocol entry\n", protocol);
 
    /* Use protocol to choose a socket type */
    if (strcmp(protocol, "udp") == 0)
        type = SOCK_DGRAM;
    else
        type = SOCK_STREAM;
 
    /* Allocate a socket */
    s = socket(PF_INET, type, ppe->p_proto);
    if (s < 0)
        errexit("can't create socket: %s\n", sys_errlist[errno]);
 
    /* For now waits for connection */
    /* while(connect(s, (struct sockaddr *)&sin, sizeof(sin)) < 0); */
    

     /* Connect the socket */
    if (strcmp(protocol, "tcp") == 0){
       if (connect(s, (struct sockaddr *)&sin, sizeof(sin)) < 0)
	{
	  /* if server is not started, reconnect again */
	  if (errno == ECONNREFUSED){ /* connection refused */
	    close(s);
	    connectsock( host, service, protocol );
	  }
	  else
	    errexit("can't connect to %s.%s: %s errno=%d\n", host, service,
		    sys_errlist[errno],errno);
	}
       
     }
    return s;  
}

int errexit(char *format, ...)

{
    va_list args;
 
    va_start(args,format);
    _doprnt(format, args, stderr);
    va_end(args);
    exit(1);
}   
