#include "debugger.h"

void stop_program(int sockfd,int AppletStop)
{
    int status;
  
    fprintf(fpout,"stop_program: I am stopping program now.... \n");

    /* cancel the control thread */
    send_errmsg(0,"OK:Program stopped",deb_curCmnd); 
    status = pthread_join(control_thread_tid,NULL);
    if (status != 0)
      errexit("pthread_join:error ");
    close(ManagerSock); /* close connection to manager */
    fprintf(fpout,"DARP CLIENT: I exited \n");
    exit(0); 
}


int setjmp_(int *myline,char *fileName)
{
  /*return setjmp(files[curFile].lineInfo[*myline].jmpbuffer);  */
 return setjmp(files[findFileIndex(fileName)].lineInfo[*myline].jmpbuffer);
}

int amIinCurrentLoop(int myline,int currentLoopHeader)
{
  int k;

  k = myline;
  while(k > 0)
  {
    if ((files[curFile].lineInfo[k].isInLoop == currentLoopHeader)||
	(files[curFile].lineInfo[k].isInLoop == 0))
      break;
    k = files[curFile].lineInfo[k].parent;
 }
  if (DEBUG)
      fprintf(fpout,"myline=%d and insinloop=%d currentHeader=%d\n",
       myline,files[curFile].lineInfo[k].isInLoop,currentLoopHeader);
  if (files[curFile].lineInfo[k].isInLoop == currentLoopHeader)
    return 1;
  else
    return 0;

}

int DoWeStopHere(int myline,char *funcName,char *fileName,int sockfd)
{
   int Stop = 0,lineNumber,n; 
   int nextFindex,index;
   PARSTRUCT parstruct;
   sigset_t new,oset;
   pthread_t tid;
   

   prevLineNum = curLineNum;
   curLineNum = myline;
   prevFileName = curFileName;
   curFileName  = fileName;
   prevFuncName = curFuncName;
   curFuncName  = funcName;

   if (prevFileName == NULL){
     prevFuncName = (char *)malloc(2);
     strcpy(prevFuncName,"");
   }
   if (prevFileName == NULL ){
     prevFuncName =  (char *)malloc(2);
     strcpy(prevFuncName,"");
   }
    
  if (DEBUG)
     fprintf(fpout,
     "inside server myline = %d sock=%d ME=%d cmnd=%d stacktop=%d fn=%s curFile=%d funcName=%s max_push_id=%d\n", myline,sockfd,ME,deb_curCmnd,cstack.top,fileName,curFile,curFuncName,max_push_id); 
  
   if (files[curFile].lineInfo[myline].numOfAttachedFcalls > 0){
      /* Call attached functions for my line */
     
     fprintf(fpout," About entering callToAttachedFuncs \n");
     
     sigfillset(&new); 
     pthread_sigmask(SIG_BLOCK, &new, NULL); 
    
     parstruct.myline = myline;
     parstruct.myFuncName = curFuncName;
     parstruct.sockfd = sockfd;
         
     if ( n = pthread_create( &tid, NULL, callToAttachedFuncs, 
			    (void *)(&parstruct)) ) {
       fprintf( stderr, "pthread_create: %s\n", strerror( n ) );
       exit( 1 );
     }
    
     if ( n = pthread_join( tid, NULL ) ) {
	fprintf( stderr, "pthread_join: %s\n", strerror( n ) );
	exit( 1 );
     } 
    
     /* callToAttachedFuncs(&parstruct); */
     if (DEBUG)
        fprintf(fpout,"in debugger: after callToAttachedFuncs \n");
   }

   updateControlStack(myline);
   
   if ((deb_curCmnd == GOTOSTACKDOWN)||(deb_curCmnd == GOTOSTACKUP))
     Stop = 1;
   if (deb_curCmnd == GOTOCURSOR){
        if (myline == goToCursorLine)
	   Stop = 1;
   } 
     
   else if (((deb_curCmnd == STEPOVER)||(deb_curCmnd == NSTEPOVER)) &&
         (cstack.top <= prevStackTop ))
   { 
       if (DEBUG)
          fprintf(fpout,"Previos Command STEP cnt = %d\n",curCounter);
       if (curCounter > 0)
          curCounter --;
       if (curCounter == 0) 
	  Stop = 1;

   }
   else if ((deb_curCmnd == STEPINTO)||(deb_curCmnd == NSTEPINTO))
   {
       if (curCounter > 0)
          curCounter --;  
       if (curCounter == 0) 
	  Stop = 1;
   }
   else if ((deb_curCmnd == CONTINUE)&&(files[curFile].lineInfo[myline].onbreak))
       Stop = 1;
   else if ((deb_curCmnd == NITERATION)&&(cstack.top <= prevStackTop ))
     {
       if (!amIinCurrentLoop(myline,loopHeaderLine)){
          Stop = 1;    
          if (DEBUG)
	  fprintf(fpout,
	  "Ok ME = %d I went oout of loop before indicated times:%d - %d\n",
           ME,files[curFile].lineInfo[myline].isInLoop,loopHeaderLine);
       }
       else if ((curCounter > 0)&&
		((myline ==  nIterStartLine)||
		 ((nIterStartLine == loopHeaderLine)&&
		  (loopHeaderLine == files[curFile].lineInfo[myline].prev))))
	 {
	    if (DEBUG)
	      fprintf(fpout,"ITERATION : %d\n", curCounter);
            curCounter--;
	 }
       if (curCounter == 0) 
	   Stop = 1;
     }
   if (is_staying_in_server == STAYINSERVER)
      Stop = 1; 
  


   nextFindex = findFileIndex(curFileName);
   /* check the program termination */
   if ((!strcasecmp(mainFuncName,curFuncName))&&
       (files[nextFindex].lineInfo[myline].isReturnPoint)&&
       (!Stop)){

      /* Control thread will extract and 
         send STOPPROGRAM command  to manager */
      send_errmsg(0,"OK ",STOPPROGRAM);
      is_staying_in_server = STAYINSERVER;
      return is_staying_in_server;
    }

   if (!Stop){ 
      if (DEBUG)
         fprintf(fpout,"I am exiting now,non-stop \n"); 
      is_staying_in_server = EXITFROMSERVER; 
      return EXITFROMSERVER;
   }

   
   /* Send myline to Java Applet which updates current line number */
   /* for beginning, wait for connection request */
   /* do not send the myline number to Applet */
   if (is_staying_in_server == EXITFROMSERVER){
           /*If we moved to one function code which is in another file 
           other than current one, Applet will request new file source 
           code from HTTP server if it doesnt have */

     if (strcmp(curFileName,prevFileName)){ 
           /* We are going to debug one function in another file, 
	   send command to applet which will request  this file, 
	   and open  its parse tree */
           int index;
           if (DEBUG)
             fprintf(fpout,"I(%d) am sending the file : %s\n",ME,curFileName);
	   index = nextFindex; /*findFileIndex(curFileName); */

	   /* Control thread will extract curFileName from ack. message 
	      and send GETNEWFILE command  to manager */
	   send_errmsg(0,curFileName,GETNEWFILE);
           
           curFile = index;
	   curFunction = findFuncIndex(curFuncName,curFileName);

	   /* Control thread will extract projectfilename from ack. message 
	      and send OPEN_PROJECT command  to manager */
	   send_errmsg(0,files[curFile].depFileName,OPEN_PROJECT);

           if (DEBUG)
             fprintf(fpout,"I(%d) sent the file : %s\n",ME,curFileName);
     }
     
       /* check the program termination */
       if ((!strcasecmp(mainFuncName,curFuncName))&&
	   (files[curFile].lineInfo[myline].isReturnPoint))
	 {
	    /* Control thread will extract and 
                send STOPPROGRAM command  to manager */
	    send_errmsg(0,"OK ",STOPPROGRAM);
  	    fprintf(fpout,"ME=% stops program line=%d\n",ME,myline);
       }
       else
	 send_errmsg(0,"OK ",myline);  /* Send my line */

       if (DEBUG)
	 fprintf(fpout,
		 "We ME = %d send current line = %d toApplet \n",ME,myline);
   }
         
   is_staying_in_server = STAYINSERVER;
   /* If this is first time we enter into this function (program just started)
      send the current line to manager which broadcats it to applets */
   if (deb_curCmnd == 0){
     deb_curCmnd =  START; /* this should be ack. of start command */
     send_errmsg(0,"OK ",myline);  /* Send my line */
   }
   
   if (DEBUG)
     fprintf(fpout,"after DoWeStopHere..\n");     
   /* Stop at this line, and wait for user commands */
   return is_staying_in_server;
  
}
   

int server (int myline,char *funcName,char *fileName)
{
   int Stop = 0,lineNumber,i; 
   char variableName[256],SciVisHost[256],SciVisPort[256];
   int status,temp;
   char msg[256];
   int errcode=0,fd,ret,nextFindex,index;
   int n,recv_status,ack;  
   pthread_t tid;
   static char curWebFlowConfig[MAXVARLEN];
   DQUEUE citem;
   
   /* send_errmsg(0,"OK ",myline); */

   isInsideDARPServer = 1;

   if (DEBUG)
     fprintf(fpout,"DARP CLIENT: waiting command from control client ...\n");
   /* Wait on debugger command queue until there is one */
   remove_command_q(&citem);
   deb_curCmnd    = citem.commandTag;
   lineNumber     = citem.lineNumber;
   if (DEBUG)
     fprintf(fpout,"I got command,deb_curCmnd=%d lineNumber=%d targetPid=%d\n",
	     deb_curCmnd,lineNumber,targetPid);
   
   prevStackTop = cstack.top;
   if (DEBUG)
      fprintf(fpout,"read new command = %d\n",deb_curCmnd);

   switch(deb_curCmnd){
   case GOTOCURSOR:
     curCounter = lineNumber ;
     if (!(files[curFile].lineInfo[curCounter].isExecutable)){
        send_errmsg(-1,"This Line is not executable ",myline);
        errcode = -1;
        is_staying_in_server = STAYINSERVER; 
     }
     else{
        goToCursorLine = curCounter;
        is_staying_in_server = EXITFROMSERVER;
	if (DEBUG)
	  fprintf(fpout,"Current counter = %d myline : %d\n",
		  curCounter,myline);
	if (curCounter < myline){
	  if (DEBUG)
	    fprintf(fpout,"I am going back to line : %d\n",goToCursorLine);
	  send_errmsg(0,"OK ",myline);
	  longjmp(files[curFile].lineInfo[curCounter].jmpbuffer,1);
	} 
     }
     
     break; 

   case PUTBREAKONOFF :
     if (DEBUG)
        fprintf(fpout,"line number = %d\n",lineNumber);
     if (!(files[curFile].lineInfo[lineNumber].isExecutable)){
        send_errmsg(-1,"This Line is not executable ",myline);
        errcode = -1;
     }
     else{
       if (files[curFile].lineInfo[lineNumber].onbreak == BREAKON){
          files[curFile].lineInfo[lineNumber].onbreak = BREAKOFF;
	  numberOfBreakPoints--;
	  send_errmsg(0,"OK",lineNumber);   
       }
       else{
          files[curFile].lineInfo[lineNumber].onbreak = BREAKON;
	  numberOfBreakPoints++;
	  send_errmsg(0,"OK",lineNumber);
       }
     }
     is_staying_in_server = STAYINSERVER;
     break;

   case STEPOVER:
     curCounter = 1;
     is_staying_in_server = EXITFROMSERVER;
     break;
   case STEPINTO:
     curCounter = 1;
     is_staying_in_server = EXITFROMSERVER;
     break;

   case NSTEPOVER:
     curCounter = lineNumber;
     is_staying_in_server = EXITFROMSERVER;
     break;

   case NSTEPINTO: 
     curCounter = lineNumber;
     is_staying_in_server = EXITFROMSERVER;
     break;

   case CONTINUE:
     is_staying_in_server = EXITFROMSERVER;
     break;

   case RUN: 
     is_staying_in_server = EXITFROMSERVER;
     break;

   case NITERATION:
     curCounter = lineNumber;
     if (!(files[curFile].lineInfo[myline].isInLoop)){
        send_errmsg(-3,"You are not in one loop",myline);
        is_staying_in_server = STAYINSERVER;
        errcode = -3;
     }
     else{
        nIterStartLine = myline;
        loopHeaderLine = files[curFile].lineInfo[myline].isInLoop;
        is_staying_in_server = EXITFROMSERVER;
     }
     if (nIterStartLine == loopHeaderLine)
       curCounter++;
     break;
   
   case STOP:
     stop_program(ManagerSock,0); 
     break;

   case GOTOSTACKDOWN:
     if (cstack.top == stackLength){
       errcode = -7;
       strcpy(msg,"You can not go stack down.!!!");
       send_errmsg(errcode,msg,myline);
       is_staying_in_server = STAYINSERVER; 
     }
     else{
       send_errmsg(0,"OK ",myline);
       is_staying_in_server = EXITFROMSERVER;
       gotoStackDown();
     }
     break;
   
  case GOTOSTACKUP:
     if (cstack.top == 0){
       errcode = -8;
       strcpy(msg,"You can not go stack up.!!!");
       send_errmsg( errcode,msg,myline);
       is_staying_in_server = STAYINSERVER;
     }
     else{
       send_errmsg(0,"OK ",myline);
       is_staying_in_server = EXITFROMSERVER;
       gotoStackUp();
     }
     break;

   } /* switch */    
   isInsideDARPServer = 0;
   return is_staying_in_server;
}



void *callToAttachedFuncs(void *x_pars)
{
  int myNumOfFuncs,i;
  AFCALLS *pf;
  char temps[4096];
  int myline;
  char *myFuncName;
  PARSTRUCT *parstruct = (PARSTRUCT *)x_pars;

  /* Set signal handler */
  /* set_signal_handler(interrupt);  */


  myline = parstruct->myline;
  myFuncName = parstruct->myFuncName ;
  myNumOfFuncs = files[curFile].lineInfo[myline].numOfAttachedFcalls;
  if (DEBUG){
    fprintf(fpout,"myNumOfFuncs : %d myline=%d\n",myNumOfFuncs,myline);
  }
  for(i=0;i<myNumOfFuncs;i++)
    executeActionPoints(myline,i,parstruct->sockfd);
}

write_int(char *s,int n)
{

   if (ME){
     fpout = fopen("output_1","a+");
     fprintf(fpout,"%s-%n\n",s,n);
     fclose(fpout);
   }


}

write_me(char *s)
{
  char fname[64];
  FILE *fx;
  sprintf(fname,"output_%d",ME);
  fx = fopen(fname,"a+");
  fprintf(fx,"%s\n",s);
  fclose(fx);  

}

void free_space_for_fcall(AFCALLS *pf)
{
  int k;
  
  free(pf->fname);
  free(pf->parIndices);
  free(pf->fcallString);
  for(k=0;k<pf->numOfParams;k++)
    free(pf->params[k]);
    
}

void executeActionPoints(int myline,int nthf,int sockfd)
{

   #define PI(i) ((int *)(stack[pf->parIndices[i]].buf))
   #define PD(i) ((double *)(stack[pf->parIndices[i]].buf))
   char funcName[256],windowName[256],*sp;
   AFCALLS *pf;
   int nparams,i,index,tnum=0;

   pf = &(files[curFile].lineInfo[myline].attachedFcalls[nthf]);
   nparams = pf->numOfParams;
   strcpy(funcName,pf->fname);
   if (strstr(funcName,"java_")){
     sp = pf->params[0];
     strcpy(windowName,sp+1);
     sp = strchr(windowName,'\"');
     if (sp)
       *sp = 0;
     
     /* strcpy(windowName,pf->params[0]);  */
   }
   
   
   if (!strcasecmp(funcName,"timer")){
      double timeval;
      timeval = timer();
      files[curFile].lineInfo[myline].elapsed_time += timeval;
      (files[curFile].lineInfo[myline].nexecution)++;
      if (DEBUG)
        fprintf(fpout,"Clock timeval : %f\n",timeval);
      return;
   }

    /*************************************************************/
   /* If we are calling function sending data to webflow module */
   if (strstr(funcName,"WebFlow_")){
     int parIndex,WebSock,fd,isContinue;    
     /* This function has only one parameter, variable name to send its
	contents to WebFlow Module */
     if (DEBUG)
       fprintf(fpout,"I am callind WEBFLOW send function \n");

     if (strstr(stack[pf->parIndices[0]].name,"LOCAL_"))
        parIndex = stack[pf->parIndices[0]].distIndex;
     else
        parIndex = pf->parIndices[0];
     
     /* parIndex = stack[pf->parIndices[0]].distIndex; */
     WebSock  = pf->WebFlowSockfd; 
     fprintf(fpout,"parIndex = %d WebSock = %d params=%s\n",
	    parIndex,WebSock,pf->params[0]);
     send_registered_data(pf->params[0],parIndex,WebSock);
     if (DEBUG)
       fprintf(fpout,"Host send the data for %s\n",pf->params[0]);
     return;
     
    
   }
   /* Finished of WebFlow */
   /*************************************************************/


   if (DEBUG)
     fprintf(fpout,"ME =%d fname : %s windowName:%s nparams=%d\n",
	     ME,funcName,windowName,nparams);

   for(i=1;i<nparams;i++){
     fprintf(fpout,"params[%d] = %s\n",i,stack[pf->parIndices[i]].name);
        
     /* If the corresponding variable is distributed, copy it to local var.*/
     if (strstr(stack[pf->parIndices[i]].name,"LOCAL_")){
        index = stack[pf->parIndices[i]].distIndex;
        copy_from_parallel_to_serial(index);
     }
   }

   if (!HOST)
     return;  
      
   if (DEBUG)
     fprintf(fpout,"I am ready to call the function : -%s- %d \n",
	  funcName,strlen(funcName));
   
   fprintf(fpout,"I am ready to call the function : -%s- %d \n",
	  funcName,strlen(funcName));

   if (!strcasecmp(funcName,"java_ser_")){
     java_ser_(windowName,PD(1),PD(2),PD(3),PI(4));
   }
   else if (!strcasecmp(funcName,"store1d_data_")){
     if (DEBUG)
       fprintf(fpout,"Before calling : %s\n","store1d_data_");
     if (HOST)
       store1d_data_(windowName,PD(1),PD(2),PD(3),PI(4));
   }
   else if (!strcasecmp(funcName,"java_fser_")){
     java_fser_(windowName,PD(1),PD(2),PD(3),PI(4));
   }
   else  if (!strcasecmp(funcName,"java_mser_")){
     java_mser_(windowName,PI(1),PD(2),PD(3),PD(4),PI(5));
   }
   else  if (!strcasecmp(funcName,"java_ser2d_")){
     java_ser2d_(windowName,PD(1),PD(2),PD(3),PD(4),PI(5));
   }
   else  if (!strcasecmp(funcName,"java_ser2d_")){
     java_ser2d_(windowName,PD(1),PD(2),PD(3),PD(4),PI(5));
   }
   else  if (!strcasecmp(funcName,"store2d_data_")){
     if (HOST)
       store2d_data_(windowName,PD(1),PD(2),PD(3),PD(4),PI(5));
   }
   else  if (!strcasecmp(funcName,"java_mser2d_")){
     java_mser2d_(windowName,PI(1),PD(2),PD(3),PD(4),PD(5),PI(6));
   }
   else  if (!strcasecmp(funcName,"java_bser2d_")){
     java_bser2d_(windowName,PD(1),PD(2),PI(3),PD(4),PI(5),PD(6));
   }
   else  if (!strcasecmp(funcName,"java_bmser2d_")){
     java_bmser2d_(windowName,PI(1),PD(2),PD(3),PI(4),PD(5),PI(6),PD(7));
   }
   else  if (!strcasecmp(funcName,"java_bbser2d_")){
     java_bbser2d_(windowName,PD(1),PD(2),PI(3),PI(4),PD(5));
   }
   else  if (!strcasecmp(funcName,"java_bbmser2d_")){
     java_bbmser2d_(windowName,PI(1),PD(2),PD(3),PI(4),PI(5),PD(6));
   }
   else  if (!strcasecmp(funcName,"java_vser_")){
     java_vser_(windowName,PD(1),PD(2),PD(3),PD(4),PD(5),PI(6));
   }
   else  if (!strcasecmp(funcName,"java_vmser_")){
     java_vmser_(windowName,PI(1),PD(2),PD(3),PD(4),PD(5),PD(6), PI(7));
   }
   else  if (!strcasecmp(funcName,"java_bbser_")){
     if (DEBUG)
       fprintf(fpout,"Before  java_bbser_ \n");
     java_bbser_(windowName,PD(1),PD(2),PI(3),PD(4));
     if (DEBUG)
       fprintf(fpout,"After java_bbser_ \n");
   }
   else  if (!strcasecmp(funcName,"java_bbmser_")){
     java_bbmser_(windowName,PI(1),PD(2),PD(3),PI(4),PD(5));
   }
   

}



void send_errmsg(int errorcode,char *errormsg,int myline)
{
   char msg[256];

   sprintf(msg,"%s: %d\n",errormsg,myline);
   /* Insert ack. message into ack. queue */
   if (((HOST)&&(applicationType == SIMD))||
                (applicationType == MIMD)||
                (deb_curCmnd == STOP))
     insert_ack_q(msg,errorcode,myline,deb_curCmnd);
        
   if (DEBUG)
        fprintf(fpout,"I will send ERRMSG =%s code=%d\n",msg,errorcode);   
}

int findFileIndex(char *curFileName)
{
   int i,index=-1;

   for(i=0;i<nfiles;i++){
     if (!strcmp(files[i].fileName,curFileName))
       index = i;
   }
   
   if (index < 0){
     fprintf(fpout,"ME:%d I could not found the file : %s\n",ME,curFileName);
     exit(0);
   }
   return index;
}
  
int findFuncIndex(char *curFuncName,char *curFileName)
{
   int i,fileInd,index=-1;

   
   fileInd = findFileIndex(curFileName);

   for(i=0;i<files[fileInd].nfuncs;i++){
     
     if (!strcmp(files[fileInd].functab[i].funcName,curFuncName)){
       index = i;
       break;
     }
   }
   if (index < 0){
     if (DEBUG)
        fprintf(fpout,"findFuncIndex : ME= %d I could not find the function : %s\n",
		ME,curFuncName);
     exit(0);
   }
   return index;
}


/* WORK on THIS */ 
void sendFileIndex(char *curf,char *nextf)
{
  int index;
   
  /* If files are same, Do not send new file index to applet */
  if (!strcasecmp(curf,nextf))
    return;

  index = findFileIndex(nextf);
  /*if (HOST){
      send_int(sockfd,GETNEWFILE);
      send_String(sockfd, nextf);
   } */
   curFile = index;

   /*send_int(SageServerSock,OPEN_PROJECT);
   send_String(SageServerSock,files[curFile].depFileName);   
   */
   if (DEBUG)
      fprintf(fpout,"sendFileIndex : I(%d) sent the file : %s\n",
	      ME,nextf);
   curFileName  = nextf;
}

int gotoStackUp()
{
   int index,fileInd,lineNum;

   index = cstack.top ;

   fileInd = findFileIndex(cstack.sInfo[index].fileName);
   if (DEBUG)
     fprintf(fpout,"In gotoStackUp: prevfile:%s fileind:%d\n",
	    cstack.sInfo[index].fileName,fileInd);

   lineNum = cstack.sInfo[index].lineNum;
   if (DEBUG)
     fprintf(fpout,"prev lineNumber : %d index=%d\n",lineNum,index);

   /* Store my old enviroment at the stack so that 
      "gotoStackDown" should use it */
   cstack.sInfo[index].curLineNum  = curLineNum;
   cstack.sInfo[index].curFuncName = curFuncName;
   cstack.sInfo[index].curFileName = curFileName;

   sendFileIndex(curFileName,cstack.sInfo[index].fileName);
   --(cstack.top);
   prevStackTop = cstack.top;
   curFileName  = cstack.sInfo[index].fileName;
   curFuncName  = cstack.sInfo[index].funcName;
   curLineNum   = cstack.sInfo[index].lineNum;
   longjmp(files[fileInd].lineInfo[lineNum].jmpbuffer,1);
   return 0;
}

/* stack is growing downward */
int gotoStackDown()
{
   int index,fileInd,lineNum;

   index = cstack.top +1;

   fileInd = findFileIndex(cstack.sInfo[index].curFileName);
   if (DEBUG)
     fprintf(fpout,"In gotoStackDown: prevfile:%s fileind:%d\n",
	    cstack.sInfo[index].curFileName,fileInd);

   lineNum = cstack.sInfo[index].curLineNum;
   if (DEBUG)
     fprintf(fpout,"prev lineNumber : %d index=%d\n",lineNum,index);
   
   sendFileIndex(curFileName,cstack.sInfo[index].curFileName );
   ++(cstack.top);
   prevStackTop = cstack.top;
   curFileName  = cstack.sInfo[index].curFileName;
   curFuncName  = cstack.sInfo[index].curFuncName;
   curLineNum   = cstack.sInfo[index].curLineNum;
   longjmp(files[fileInd].lineInfo[lineNum].jmpbuffer,1);
   return 0;
}

void updateControlStack(int myline)
{
  int i,fexec,findex,fileInd;

  fileInd = findFileIndex(curFileName);
  findex = findFuncIndex(curFuncName,curFileName);
  /* First executable stmt */
  fexec =  files[fileInd].functab[findex].fExecStmt;  

  /* Subroutine called */
  if (strcmp(prevFuncName,curFuncName)&&(myline == fexec)){
      files[fileInd].functab[findex].isVisited = 1; 
      i = ++(cstack.top);
      cstack.sInfo[i].SaveRegStackTop = max_push_id;
      cstack.sInfo[i].lineNum  = prevLineNum;
      cstack.sInfo[i].funcName = prevFuncName;
      cstack.sInfo[i].fileName = prevFileName;

      if (DEBUG)
         fprintf(fpout,"Subroutine called  TOP =%d\n",i);
  }
  /* Return from function */
  else if (strcmp(prevFuncName,curFuncName)&&(myline != fexec)){
      (cstack.top)--;
      max_push_id = cstack.sInfo[cstack.top].SaveRegStackTop;
      if (DEBUG)
          fprintf(fpout,"Subroutine returned   TOP =%d \n",cstack.top);
  }
  stackLength = cstack.top;

}


