#include "debugger.h"

void insert_command_q(int commandTag,int lineNumber)
{
   DQUEUE *item;
  
   item = (DQUEUE *)malloc(sizeof(DQUEUE));
   item->commandTag = commandTag;
   item->lineNumber = lineNumber;
   item->next       = NULL;
      
   if ((command_q_tail == NULL)&&(command_q_head == NULL)){
      command_q_head = item;
      command_q_tail = item;
   }
   else{
     command_q_tail->next = item;
     command_q_tail       = item;
   }
  
}

int remove_command_q(DQUEUE *item)
{
   DQUEUE *save;
   int status ;
   struct timespec timeout;
   int isThere = 0;
   
   /* Remove next command */
   if (command_q_head != NULL){
     save = command_q_head;
     item->commandTag = command_q_head->commandTag;
     item->lineNumber = command_q_head->lineNumber;
     command_q_head = command_q_head->next;
     if (command_q_head == NULL)
       command_q_tail = NULL;
     free(save);
     isThere = 1;
     return isThere;
   }
   else
     return isThere;
}


int control_thread (int managerSock)
{
   int Stop = 0,lineNumber,i; 
   char variableName[256],SciVisHost[256],SciVisPort[256];
   static char tmp1[256];
   static char tmp2[256];
   char *sp1,*sp2;
   int newLineNum;
   int status,temp;
   char msg[256];
   int errcode=0,fd,ret,nextFindex,index;
   PARSTRUCT parstruct;
   sigset_t new,oset;
   int n,recv_status,ack;  
   pthread_t tid;
   static char curWebFlowConfig[MAXVARLEN];
   int paramslen,myline=curLineNum;
   char *funcName = curFuncName;   
   int *selected_pids,nprocs,subcommand;
         
   if (DEBUG)
     fprintf(fpout,"CONTROL THREAD is waiting command from client ...\n");

   /* Receive next user command */
   recv_int(managerSock,&curCmnd );
   if (DEBUG)
      fprintf(fpout,"CONTROL THREAD:read new command = %d\n",curCmnd);

   switch(curCmnd){
   case DISPLAY:
     status = 0;
     recv_String(managerSock,variableName);
     status = find_var(funcName,variableName);

     if (status < 0){
        sprintf(msg,"We could not find the variable : %s",variableName);
	send_nondebug_err_ack(curCmnd,-4,msg,myline);
        /* send_errmsg(-4,msg,myline,sockfd); */
        errcode = -4;
     }
     else{
       pack_and_send_registered_data(status,managerSock);
       /*status = send_registered_data(variableName,status,sockfd); */    
     } 
     break;

   case DISARRAYSECTION:
     arraysec_thread(myline,managerSock,funcName);
     break;

   case SETVARIABLE:
     status = 0;
     recv_String(managerSock,variableName);
     status = find_var(funcName,variableName);
     
     if (status < 0){
        sprintf(msg,"We could not find the variable : %s",variableName);
	send_nondebug_err_ack(curCmnd,-5,msg,myline);
        /* send_errmsg(-5,msg,myline,sockfd); */
        errcode = -5; 
     } 
     else{
       pack_and_send_setvar(status, managerSock);
     }
     break;

   case VARVALUE:
     recv_int(managerSock,&status);
     process_varvalue(status,managerSock);
     break;  

   case SETPARVAR:
     status = 0;
     recv_String(managerSock,variableName);
     status = find_var(funcName,variableName);
          
     if (status < 0){
        sprintf(msg,"We could not find parallel  variable : %s",variableName);
	send_nondebug_err_ack(curCmnd,-6,msg,myline);
        errcode = -6; 
     } 
     else{
        set_ParallelVar(managerSock,status);
     }
     break;    

   /* send the user hpf stmt list to Manager which forwards to sage server */
   case INTERPRET :
    recv_String(managerSock,receivedHPFList);
    send_instrument_command(INSTRUMENT,nextModule,curFuncName,receivedHPFList);
     break;

   /* receive instrumented hpf stmt list and call dynamic function */
   case INSTRUMENTED_CODE:
     interpretHPFStmt(funcName);
     break;
     
   case  SCIVISENV :
     recv_String(managerSock,SciVisHost);
     recv_String(managerSock,SciVisPort);

     /* put environment variabels SciVis will use later */
     strcpy(tmp1,"JSERHOST=");
     strcat(tmp1,SciVisHost);
     ret=putenv(tmp1);
     strcpy(tmp2,"JSERPORT=");
     strcat(tmp2,SciVisPort);
     ret=putenv(tmp2); 

     sp1 = getenv("JSERHOST"); 
     sp2 = getenv("JSERPORT"); 
     if (DEBUG)
        fprintf(fpout,"GETENV SciVisHost : %s SciVisPort : %s \n",sp1,sp2);
     send_nondebug_err_ack(curCmnd,0,"OK", myline);
     break;
   
   case SCIVIS_FUNCTION_LIST:   
     send_scivizFlist(managerSock);
     break;

   case SEND_LOCALS:
     send_localVars(managerSock,curFuncName);
     break;

   case ADD_ACTION: case DELETE_ACTION:
     /* receive function call string "java_ser_(...params..) */
     recv_String(managerSock, receivedHPFList); 
     /* Receive line number on which you put function call */
     recv_int( managerSock,&newLineNum); 
 
     if ((newLineNum != -1)&&
	 (!(files[curFile].lineInfo[newLineNum].isExecutable))){
       sprintf(msg,
       "You can not add/delete action to this line which is not executable:%d",
	      myline);
       send_nondebug_err_ack(curCmnd,-8,msg, myline);
     }
     else{
       /* Register received function */
       if (newLineNum != -1)
	  processAction(receivedHPFList,newLineNum,curFile); 
       else {
  	 int fsize = files[curFile].fileSize;
	 for(i=0;i<fsize;i++)
	   if (files[curFile].lineInfo[i].isExecutable)
	       processAction(receivedHPFList,i,curFile); 
       }
       pack_and_send_attach_action(managerSock,newLineNum,curCmnd);
     }
     break;

     case ACTION_LIST:
       
       pack_and_send_action_points(managerSock);
       break;

     case GET_FUNCTION:
       send_function_params(managerSock,myline);
       break;
   
     case STORE_CONFIG:
       recv_String(managerSock,receivedHPFList);
       store_config(receivedHPFList);
       send_nondebug_err_ack(STORE_CONFIG,0,"OK", myline);
       /* Store config file name for the WebFlow command */
       strcpy(curWebFlowConfig,receivedHPFList);
       break;
     
     case GET_PROFILE_DATA:
       send_profile_data(managerSock);
       break;

     case WEBFLOW:  
       read_Config_File(curWebFlowConfig,managerSock);
       /* For now do not return anything to WebFlow Module */
       break;
     case APPLY_CONFIG :  
       recv_String(managerSock,receivedHPFList);
       apply_Config_File(receivedHPFList, myline);
       break;
     case SEND_CONFIGS  :
       readConfigAndSend(".config");
       break;

     case READ_PARSE_TREE:
       recvParseTree_from_manager();
       break;
          
     case PAUSE:
       /* Be careful about the following lines */
       /* These lines should be protected by mutexes */
       is_staying_in_server = STAYINSERVER;
       send_nondebug_err_ack(curCmnd,0,"Paused",curLineNum);
       send_errmsg(myline,curFileName,GETNEWFILE);   
       break;
     
     /* we move this putting break point command here because we need
	to put break point while program is running */
     case PUTBREAKONOFF :
         recv_int( managerSock,&lineNumber); 
	 if (DEBUG)
	   fprintf(fpout,"line number = %d\n",lineNumber);
	 if (!(files[curFile].lineInfo[lineNumber].isExecutable)){
	   errcode = -1;
	   send_nondebug_err_ack(PUTBREAKONOFF,errcode ,
				 "This Line is not executable",lineNumber);
	 }
	 else{
	   if (files[curFile].lineInfo[lineNumber].onbreak == BREAKON){
	     files[curFile].lineInfo[lineNumber].onbreak = BREAKOFF;
	     numberOfBreakPoints--;
	     send_nondebug_err_ack(PUTBREAKONOFF,0,"OK",lineNumber);
	   }
	   else{
	     files[curFile].lineInfo[lineNumber].onbreak = BREAKON;
	     numberOfBreakPoints++;
	     send_nondebug_err_ack(PUTBREAKONOFF,0,"OK",lineNumber);
	   }
	 }
         break;   
       
     /* If it is debugger command, then forward it to computation thread */
     case NSTEPOVER:case NSTEPINTO:case NITERATION:
          case GOTOCURSOR:
       recv_int(managerSock,&lineNumber);
       insert_command_q(curCmnd,lineNumber);
       break;
     /* If it is debugger command, then forward it to computation thread */
     case STEPOVER:case STEPINTO: case CONTINUE:
     case RUN: case STOP:case GOTOSTACKDOWN:case GOTOSTACKUP:
       insert_command_q(curCmnd,0);  
       break;
          

     default:
       printf("Unknown DARP server command..\n");
   } /* switch */

   /* return new received command */
   return curCmnd;
   
}

void recvParseTree_from_manager()
{
  int fsize,fnfuncs,f,j;
  int buflen;
    
  /* Receive parse tree from Sage Server */
  recv_int(ManagerSock,&nfiles);
  files = (FILES *)calloc(nfiles,sizeof(FILES));
  for(f=0;f<nfiles;f++){
    recv_raw_data(ManagerSock,(char *)(&files[f]),sizeof(FILES));
    recv_int(ManagerSock,&fsize);
    recv_int(ManagerSock,&fnfuncs );
    files[f].fileSize = fsize ;
    files[f].nfuncs = fnfuncs ; 
    files[f].lineInfo = (SINFO *)calloc(fsize,sizeof(SINFO));
    files[f].functab  = (FTAB *)calloc(fnfuncs,sizeof(FTAB));

    /* Later also change the following two lines by using XDR library*/
    recv_raw_data(ManagerSock,(char *)(files[f].functab),
		  sizeof(FTAB)*fnfuncs);
    recv_raw_data(ManagerSock,(char *)(files[f].lineInfo),
		  sizeof(SINFO)*fsize);

    for(j=0;j<files[f].fileSize;j++){ 
      AFCALLS *tpf;
      tpf = (AFCALLS *)calloc(MAX_FCALLS,sizeof(AFCALLS)); 
      files[f].lineInfo[j].attachedFcalls =  tpf;
    }
  }
  printf("CONTROL CLIENT got Parse tree Information !!!\n");
     
}

void hpf_server_(int *myline,char *funcName,char *fileName)
{
  int     sresult;
  DQUEUE debugger_command;
  clock_t ts,te;
   
  server_ncalls++;

  /*just for benchmarking */
  ts = clock();
  
         
  if (DEBUG)  
    fprintf(fpout,"before hpf_server:line:%d in file:%s \n",*myline,fileName); 
  
  /* check that we will stop here or not */
  sresult = DoWeStopHere(*myline,funcName,fileName);

  /* If there is available user command, read it an process it */
  /* Put debugger commands into command_q DARP client takes and process */
  if (isDataAvailable())
      control_thread (ManagerSock);
  
  if (sresult == EXITFROMSERVER){
    if (DEBUG)
      fprintf(fpout,"after DoWeStopHere:line:%d :ME:%d",*myline,ME); 
    /* return; */
  }

  while (sresult == STAYINSERVER ) 
  {
      if (isDataAvailable())
	control_thread (ManagerSock);
      if (remove_command_q(&debugger_command))
	 sresult = server(*myline,funcName,fileName,debugger_command);

  } 

  if (DEBUG)
     fprintf(fpout,"Exiting  HPF server line:%d :ME:%d",*myline,ME); 

  /* For benchmarking purpose */
  te = clock();
  if  (server_ncalls > 1) /* exclude initial waiting time to get "continue" */
    server_acc += te-ts;
  if ((server_ncalls == 1) && (gettimeofday(&start_gettimeofday,NULL)< 0))
    errexit("gettimeofday error !!!\n");  
  /**************************************/
}


/* check Manager port whether or not any data is available to read */
int isDataAvailable()
{
    int    maxfdp1;
    fd_set rset,allset;
    struct timeval tval={0,0};
    int isAvailable = 0;
    
    maxfdp1 = ManagerSock + 1;
    FD_ZERO(&rset);
    FD_SET(ManagerSock, &rset);

    for(; ;){
      if ( (select(maxfdp1, &rset, NULL, NULL, &tval)) < 0) {
          if (errno == EINTR)
              continue;               /* back to for() */
           else
	     errexit("select error");
      }
      if (FD_ISSET(ManagerSock, &rset)) 
	isAvailable =  1;
      break;
    }
    
    return isAvailable;
}

void process_debug_ack(char *errmsg,int errcode,int myline,int commandTag )
{
   char *buffer,*ts;
   int ackmsglen,mypid = ME;
   XDR xdrs;
   int buflen;
   int exit_status;
         
   /* send this command to sage server */
   if (myline == OPEN_PROJECT){
      send_sage_server_command(OPEN_PROJECT,errmsg);
      return;
   }
   /* If it got STOP command,exit */
   if (commandTag == STOP)
      pthread_exit(&exit_status);
   
   buffer = (char *)malloc(REGBUFSIZE);
   xdrmem_create(&xdrs,buffer,REGBUFSIZE,XDR_ENCODE); 
   ts = (char *)malloc(MAXVARLEN);
   
   xdr_int(&xdrs,&(commandTag));
   /* The current line number debugger reached */
   xdr_int(&xdrs,&(myline));
   xdr_int(&xdrs,&mypid);
   xdr_int(&xdrs,&(errcode));
   /* ts = make_errmsg(errmsg,myline);*/
   strcpy(ts,errmsg);
   xdr_string(&xdrs,&ts,strlen(ts)); 
   ackmsglen = xdr_getpos(&xdrs);
   
      
   /* first send the ack. command tag to the manager */
   send_int(ManagerSock,ACKCOMMAND);

   /* And send the total message length */
   send_int(ManagerSock,ackmsglen);

   /* send this "commandTag+pid+errcode+actualAckMessage+myline" to manager */
   send_raw_data(ManagerSock,buffer,ackmsglen);
   
   /* xdr_destroy(&xdrs); */
   free(ts);
   free(buffer);
}


void send_nondebug_err_ack(int commandTag,int errcode,
            char *errmsg,int myline)
{
   char *buffer,*ts;
   int ackmsglen,mypid = ME;
   XDR xdrs;

   if ((commandTag == PUTBREAKONOFF)&&
       (!((applicationType == SIMD)&&HOST)|| 
          (applicationType == MIMD)))
     return;
   
   ts = (char *)malloc(MAXVARLEN); 
   buffer = (char *)malloc(REGBUFSIZE);
   xdrmem_create(&xdrs,buffer,REGBUFSIZE,XDR_ENCODE); 

   xdr_int(&xdrs,&commandTag);
   /* The current line number debugger reached */
   xdr_int(&xdrs,&myline);
   xdr_int(&xdrs,&mypid);
   xdr_int(&xdrs,&errcode);
   /*ts = make_errmsg(errmsg,myline); */
   strcpy(ts,errmsg);
   xdr_string(&xdrs,&ts,strlen(ts));
   ackmsglen = xdr_getpos(&xdrs);
      
   /* first send the ack. command tag to the manager */
   send_int(ManagerSock,ACKCOMMAND);

   /* And send the total message length */
   send_int(ManagerSock,ackmsglen);

   /* send this "commandTag+pid+errcode+actualAckMessage+myline" to manager */
   send_raw_data(ManagerSock,buffer,ackmsglen);
   
   /* xdr_destroy(&xdrs); */
   free(ts);
   free(buffer);
}


void store_config(char *ConfigFile)   
{
   FILE *fp;
   char HPFExecName[MAXVARLEN],*p,prefix[MAXVARLEN];
   int i,fsize,k,j,myNumOfFuncs;
        
   if (!(fp = fopen(ConfigFile,"w"))){
     fprintf(fpout,"I could not open the file : %s\n",ConfigFile);
     return;
   }

   /* Remove all the path sequence if any,e.g. /A/B/C/xxxx.prj */
   if (p = (strrchr(projectName,'/')))
   {
     k = p - projectName;
     strncpy(prefix,projectName,p-projectName);
     prefix[k] = 0;
     sprintf(HPFExecName,"%s/demo_%s",prefix,p+1);
   }
   else
     sprintf(HPFExecName,"demo_%s",projectName); 

   *strrchr(HPFExecName,'.') = 0;   
   /* Write HPF executable name */
   fprintf(fp,"%s\n",HPFExecName);
   /* Write the port number I am listening */
   fprintf(fp,"%s\n",ManagerPort);  

   /* Write total number of action points */
   fprintf(fp,"%d\n",numberOfActionPoints);
   /* write action points as : lineNumber and fcall  and filename  */
   /* Get the file size of current file */

   
   for (k=0;k<nfiles;k++)
   {
     fsize = files[k].fileSize;
     for(i=0;i<fsize;i++){
       myNumOfFuncs = files[k].lineInfo[i].numOfAttachedFcalls;
       if (myNumOfFuncs > 0){
         for(j=0;j<myNumOfFuncs;j++)
	    fprintf(fp,"%d %s %s\n",
		 i,files[k].lineInfo[i].attachedFcalls[j].fcallString,
		    files[k].fileName);
       }
     }
   }
     
   /* Write total number of break points */
   fprintf(fp,"%d\n",numberOfBreakPoints);
   /* write break points as : lineNumber and filename pairs */
   for (k=0;k<nfiles;k++)
   {
     fsize = files[k].fileSize;
     for(i=0;i<fsize;i++){
       if (files[k].lineInfo[i].onbreak == BREAKON)
	 fprintf(fp,"%d %s\n",i,files[k].fileName);
     }
   }
      
   
   fclose(fp);

   /* copy this file under dir. ../../../htdocs/VPL-html */
   sprintf(HPFExecName,"cp %s  ../../../htdocs/VPL-html/", ConfigFile);
   system(HPFExecName);
}


void read_Config_File(char *ConfigFile,int sockfd)
{
  FILE *fp;
  char buf[REGBUFSIZE],*sp,sline[64],fcall[REGBUFSIZE];
  int  numOfActions,k,lineNumber,index,findex,WebSock;
  char host[REGBUFSIZE],port[REGBUFSIZE];
      
  if (!(fp = fopen(ConfigFile,"r"))){
     fprintf(fpout,"I could not open the file : %s\n",ConfigFile);
     exit(1);
  }
  /* Read HPF Executable name, 
     HPF Server port and number of action points respectively*/
  fgets(buf,sizeof(buf),fp);
  fgets(buf,sizeof(buf),fp);
  /* We need only number of action points */
  fgets(buf,sizeof(buf),fp);
  numOfActions = atoi(buf);

  /*Configuration file will includes linenumber and function call string
    -lineNumber WeBFlow_xxx/java_xxx/timer(varname)-
    there is at least one space between them  at each line of file */
  /*****************************************************************/
  for(k=0;k<numOfActions;k++){
    fgets(buf,sizeof(buf),fp);
    /*Extract line Number  */
    sp = strchr(buf,' ');
    strncpy(sline,buf,sp-buf);
    sline[sp-buf] = 0;
    lineNumber = atoi(sline);
    /*Extract function call string */    
    strcpy(fcall,sp);
    
    /* If WebFlow function */
    if (strstr(fcall,"WebFlow_")){
	recv_String(sockfd,host);
	recv_String(sockfd,port);
	WebSock = connectsock( host, port,"tcp");

        if (DEBUG)
           fprintf(fpout,"-%s- with  has webflow sock=%d\n",
	       fcall,WebSock);
    }
    
    /*****************************************************/
    /* Because only HOST will connect to WebFlow module,**/ 
    /****"WebSock" is not important for other processors.*/
    /*** So we did not distribute it *********************/
    /*****************************************************/
    if (index >= 0){
      AFCALLS *pf;
      pf = &(files[curFile].lineInfo[lineNumber].attachedFcalls[index]);
      pf->WebFlowSockfd = WebSock;
    }  
    
  }
  fclose(fp);
     
}


void apply_Config_File(char *ConfigFile,int myline)
{
  FILE *fp;   
  char buf[MAXVARLEN],*sp,sline[128],*filename,fcall[FCALLSTRLEN];
  int  numOfActions,k,lineNumber,index,findex,WebSock,numOfBreaks;
  int  *lines,nlines=0;
  char **fnames;
  char *buffer,*tsbuf;
  XDR  xdrs;
    
  index = -1;
  
  if (!(fp = fopen(ConfigFile,"r"))){
     fprintf(fpout,"I could not open the file : %s\n",ConfigFile);
     exit(1);
  }

  /* create buffer area for storing encoded XDR data */       
  buffer = (char *)malloc(REGBUFSIZE);
  xdrmem_create(&xdrs,buffer,REGBUFSIZE,XDR_ENCODE);

  /* first pack ack. message before actual data */
  tsbuf = make_errmsg("OK",myline); 
  pack_nondebug_ack(myline,curCmnd,0,tsbuf,&xdrs);

  /* Read HPF Executable name, 
     HPF Server port and number of action points respectively*/
  fgets(buf,sizeof(buf),fp);
  fgets(buf,sizeof(buf),fp);
  
  /* We need only number of action points */
  fgets(buf,sizeof(buf),fp);
  numOfActions = atoi(buf);
  lines = (int *)malloc(numOfActions*sizeof(int));
  fnames = (char **)malloc(sizeof(char *)*numOfActions);
  
  /*Configuration file will includes linenumber and function call string
    -lineNumber WeBFlow_xxx/java_xxx/timer(varname)-
    there is at least one space between them  at each line of file */
  /*****************************************************************/
  for(k=0;k<numOfActions;k++){
    fgets(buf,sizeof(buf),fp);
    
    /*Extract line Number  */
    sp = strchr(buf,' ');
    strncpy(sline,buf,sp-buf);
    sline[sp-buf] = 0;
    lineNumber = atoi(sline);
    
    /*Extract function call string and  filename*/    
    strcpy(sline,sp);  
    strcpy(fcall,strtok(sline,")\n\r"));
    strcat(fcall,")");
    filename =  strtok(NULL,")\n\r");
    filename++; /* there is blank between fcall and filename */

    if (DEBUG) 
      fprintf(fpout,"Apply action point with line=%d fcall=%s file=%s l=%d\n",
		lineNumber,fcall,filename,strlen(filename));
    findex = findFileIndex(filename);
    /*Add this Function Call to the corresponding line */
    index = processAction(fcall,lineNumber,findex); 
    if (index >= 0){
      lines[nlines] = lineNumber;
      fnames[nlines] = (char *)malloc(strlen(filename)+1);
      strcpy(fnames[nlines],filename);
      nlines++;
    }
  }  

  /* Pack the action point lines to Applet */
  pack_send_multiple_Strings(fnames,NULL,lines,nlines,&xdrs);   

  /* Delete allocated stuff */  
  for(k=0;k<nlines;k++)
    free(fnames[k]);
  free(lines);
  free(fnames);

  /* Attach break points */
  fgets(buf,sizeof(buf),fp);
  numOfBreaks = atoi(buf);
  lines = (int *)malloc(numOfBreaks*sizeof(int));
  fnames = (char **)malloc(numOfBreaks*sizeof(char *));
  nlines = 0;
  
  for(k=0;k<numOfBreaks;k++){
    fgets(buf,sizeof(buf),fp);
    lineNumber = atoi(strtok(buf,"\n\r "));
    filename = strtok(NULL,"\n\r ");
    findex = findFileIndex(filename);
    if (DEBUG) 
        fprintf(fpout,"Apply break point with line=%d file=%s\n",
		lineNumber,filename);
    if (files[findex].lineInfo[lineNumber].isExecutable){
      if (files[findex].lineInfo[lineNumber].onbreak == BREAKON){
          files[findex].lineInfo[lineNumber].onbreak = BREAKOFF;
	  numberOfBreakPoints--;
      }
      else{
	  files[findex].lineInfo[lineNumber].onbreak = BREAKON;
	  numberOfBreakPoints++;
      }
      lines[nlines] = lineNumber;
      fnames[nlines] = (char *)malloc(strlen(filename)+1);
      strcpy(fnames[nlines],filename);
      nlines++;

    }
  }
  fclose(fp);

  /* pack the break points to Applet */
  pack_send_multiple_Strings(fnames,NULL,lines,nlines,&xdrs); 
   
  /* Finally send all the breakpoints and action points to clients */
  just_send_XDR_data(buffer,&xdrs);
  
  /* Delete allocated stuff */  
  for(k=0;k<nlines;k++)
    free(fnames[k]);
  free(lines);
  free(fnames);
  free(tsbuf);
       
}

void just_send_XDR_data(char *buffer,XDR *xdrs)
{
   int totalLen;

   if (!(((HOST)&&(applicationType == SIMD))||
                  (applicationType == MIMD)))
        return;
     
   /* first send the ack. command tag to the manager */
   send_int(ManagerSock,ACKCOMMAND);

   /* And send the total message length */
   totalLen = xdr_getpos(xdrs);
   send_int(ManagerSock,totalLen);
      
    /* Send actual packaged data */
   send_raw_data(ManagerSock,buffer,totalLen);

   /* xdr_destroy(xdrs);  */
   free(buffer);
   
}



void readConfigAndSend(char *ext)
{
  DIR *dirp;
  struct dirent *dp;
  char *cfiles[128];
  int  cn=0,k;
    
  dirp = opendir("./");
  while(dp = readdir(dirp))
    if (strstr(dp->d_name,ext)){
      cfiles[cn] = (char *)malloc(128);
      strcpy(cfiles[cn++],dp->d_name);
    }
  
  /* send the number of config files and themselves */
  send_multiple_Strings(cfiles,NULL,NULL,cn);
  closedir(dirp);
  for(k=0;k<cn;k++)
    free(cfiles[k]);
  
}


int send_function_params(int managerSock,int myline)
{
  int linenum,nthf=0,i,fsize,numOfFunctions;
  AFCALLS *pf;

  recv_int(managerSock,&linenum);
  if (linenum == -1){
    recv_int(managerSock,&linenum);
    recv_int(managerSock,&nthf);
  }
  
  fsize = files[curFile].fileSize;
  numOfFunctions = files[curFile].lineInfo[linenum].numOfAttachedFcalls;
  if (linenum >= fsize){
    send_nondebug_err_ack(curCmnd,-9,"LineNum is bigger than filesize",
                myline);
    return;
  }
  else if (!(files[curFile].lineInfo[linenum].isExecutable)){
     send_nondebug_err_ack(curCmnd,-9,"Line is not executable",
                myline);
     return;
  }
  else if (nthf >= numOfFunctions){
     send_nondebug_err_ack(curCmnd,-9,"Function order is too big",
                myline);
     return;
  }
  pf = &(files[curFile].lineInfo[linenum].attachedFcalls[nthf]);
  /* send funcName+numberOfParameters+parameterList */
  send_multiple_Strings(pf->params,pf->fname,NULL,pf->numOfParams);
}
  
double  timer()
{
   static clock_t save_time = 0;
   clock_t new_time,elapsed_time;

   new_time     = clock();
   elapsed_time = new_time-save_time;
   save_time    = new_time;
   return (((double) elapsed_time)/ CLOCKS_PER_SEC);

}

  
void send_scivizFlist(int sockfd)
{
   /* I found ther error really. You can not initialize sciviz functions
      in the following way. Maybe C++ does not like this type of 
      initialization. You have to give initial values in different way */
  /* scivizFlist[18] = {"java_fser_","java_ser_",...,"timer"} 
     --this is wrong-- */

   int funcsLength,i ;
   char *scivizFlist[21];

   funcsLength = sizeof(scivizFlist)/sizeof(scivizFlist[0]);  
   for(i=0;i<funcsLength;i++)
    scivizFlist[i] = (char *)malloc(128);
   
   
    strcpy(scivizFlist[0],"java_ser_");
    strcpy(scivizFlist[1],"java_bser2d_");
    strcpy(scivizFlist[2],"WebFlow_1");
    strcpy(scivizFlist[3],"WebFlow_2");
    strcpy(scivizFlist[4],"WebFlow_3");

    strcpy(scivizFlist[5],"java_fser_");
    strcpy(scivizFlist[6],"java_mser_");
    strcpy(scivizFlist[7],"java_fser2d_");
    strcpy(scivizFlist[8],"java_ser2d_");
    strcpy(scivizFlist[9],"java_mser2d_");
    strcpy(scivizFlist[10],"java_bmser2d_");
    strcpy(scivizFlist[11],"java_bbser2d_");
    strcpy(scivizFlist[12],"java_bbmser2d_");
    strcpy(scivizFlist[13],"java_vser_");
    strcpy(scivizFlist[14],"java_vmser_");
    strcpy(scivizFlist[15],"java_bbser_");
    strcpy(scivizFlist[16],"java_bbmser_");
    strcpy(scivizFlist[17],"java_pser_");
    strcpy(scivizFlist[18],"java_pser2d_");
    strcpy(scivizFlist[19],"java_pbbser2d_");
    strcpy(scivizFlist[20],"timer");
		   
    if ((applicationType == SIMD)&&HOST)
      send_multiple_Strings(scivizFlist,NULL,NULL,funcsLength);

    for(i=0;i<funcsLength;i++)
      free(scivizFlist[i]); 

}


void send_action_points(int sockfd)
{
   int i,fsize,myNumOfFuncs;

   /* Get the file size of current file */
   fsize = files[curFile].fileSize;
   for(i=0;i<fsize;i++){
     myNumOfFuncs = files[curFile].lineInfo[i].numOfAttachedFcalls;
     if (myNumOfFuncs > 0){
       if (myNumOfFuncs > 1){
	 send_int(sockfd,-1);
	 send_int(sockfd,i);
	 send_int(sockfd,myNumOfFuncs);
       }
       else
	 send_int(sockfd,i);
     }
   }
   /* Send the end of action point list */
   send_int(sockfd,-2);    

}

void pack_and_send_action_points(int managerSock)
{
   char *buffer,*ts;
   XDR xdrs;
   int len;
   int i,fsize,myNumOfFuncs,temp;
   
   if (!(((HOST)&&(applicationType == SIMD))||
                (applicationType == MIMD)))
        return;
   
   buffer = (char *)malloc(REGBUFSIZE);
   xdrmem_create(&xdrs,buffer,REGBUFSIZE,XDR_ENCODE);

   /* first pack ack. message before actual data */
   ts = make_errmsg("OK",curLineNum); 
   pack_nondebug_ack(curLineNum,ACTION_LIST,0,ts,&xdrs);

   /* pack the line numbers of action points */
   /* Get the file size of current file */
   fsize = files[curFile].fileSize;
   for(i=0;i<fsize;i++){
     myNumOfFuncs = files[curFile].lineInfo[i].numOfAttachedFcalls;
     if (myNumOfFuncs > 0){
       if (myNumOfFuncs > 1){
	 temp = -1;
         xdr_int(&xdrs,&temp);
	 xdr_int(&xdrs,&i);
         xdr_int(&xdrs,&myNumOfFuncs);
       }
       else
	 xdr_int(&xdrs,&i);
     }
   }
   /* pack the end of action point list */
   temp = -2;
   xdr_int(&xdrs,&temp);
   
   /*first send the ack. command tag to the manager */
   send_int(managerSock,ACKCOMMAND);

   /*And send the total message length */
   len = xdr_getpos(&xdrs);
   send_int(managerSock,len);

   /*Send actual packaged data */
   send_raw_data(managerSock,buffer,len);
  
   /* xdr_destroy(&xdrs); */
   free(buffer);
   free(ts);
}



void pack_and_send_attach_action(int managerSock,int attach_line,
   int attach_command)
{
   char *buffer,*ts;
   XDR xdrs;
   int len;
   int i,fsize,myNumOfFuncs,temp;
   
   if (!(((HOST)&&(applicationType == SIMD))||
                (applicationType == MIMD)))
        return;

   buffer = (char *)malloc(REGBUFSIZE);
   xdrmem_create(&xdrs,buffer,REGBUFSIZE,XDR_ENCODE);

   /* first pack ack. message before actual data */
   ts = make_errmsg("OK",attach_line); 
   pack_nondebug_ack(attach_line,attach_command,0,ts,&xdrs);
      
   /*first send the ack. command tag to the manager */
   send_int(managerSock,ACKCOMMAND);

   /*And send the total message length */
   len = xdr_getpos(&xdrs);
   send_int(managerSock,len);

   /*Send actual packaged data */
   send_raw_data(managerSock,buffer,len);
  
   /* xdr_destroy(&xdrs); */
   free(buffer);
   free(ts);
}



/* fcallString : java_ser_(..params..) */
int  processAction(char *fcallString,int myline,int curFile)
{
   char *funcName,*sp;
   char *params[64],saveFcall[2048];
   int pcnt,myNumOfFuncs,i,findex;
   char    *fname;
   AFCALLS *pf,*pf_1,*pf_2;
   int ssize,index,nextpIndex ;
   char *pp,*p;
   int startLoop;
   
   fprintf(fpout,"We got fcall string : %s\n",fcallString);
   strcpy(saveFcall,fcallString);
   /* grab the function name and its parameters */
   funcName = strtok(saveFcall,"\n\r\t&(), ");

   pcnt = 0;
   while((sp = strtok(NULL,"\n\r\t&(), ")))
     params[pcnt++] = sp;
      
   /* Look for whether there is same function call registered before 
      at this line with same name and same parameters */
   myNumOfFuncs = files[curFile].lineInfo[myline].numOfAttachedFcalls;
   for(i=0,findex=-1;i<myNumOfFuncs;i++){
     pf = &(files[curFile].lineInfo[myline].attachedFcalls[i]);
     if (isItSameFunction(funcName,params,pcnt,pf)){
       findex = i;
       break;
     }   
   }
   
   fprintf(fpout,"myNumOfFuncs : %d\n",myNumOfFuncs);
   if (DEBUG){  
     if (findex < 0)
       fprintf(fpout,"Function call:  is not attached to this line :%d\n",
	   myline);
     else 
       fprintf(fpout,
               "Function call:  has been already attached this line :%d\n",
	          myline); 
   }  
   if ((curCmnd == DELETE_ACTION)&&(findex >= 0))
   {  
      if (DEBUG) 
        fprintf(fpout,"deleting function call : %s\n",fcallString);

      ssize = sizeof(AFCALLS);
      for(i=findex;i<myNumOfFuncs-1;i++){
	pf_1 = &(files[curFile].lineInfo[myline].attachedFcalls[i]);
	pf_2 = &(files[curFile].lineInfo[myline].attachedFcalls[i+1]);
	free_space_for_fcall(pf_1);
	memcpy(pf_1,pf_2,ssize);
      }
      pf = &(files[curFile].lineInfo[myline].attachedFcalls[myNumOfFuncs]);
      free_space_for_fcall(pf);
      /*decrase the number of attached fcalls for this line */
      (files[curFile].lineInfo[myline].numOfAttachedFcalls)--;
      return -1;
   }
  
   /* It was already attached */
   if (findex >= 0){
     if (DEBUG) 
       fprintf(fpout,"%s is already attached \n",fcallString);
     return -1;
   }

   if (DEBUG) 
     fprintf(fpout,"Append this function call : %s with pcnt=%d \n",
	      fcallString,pcnt);
   
   /*** Append this function call to my fcall attached list ***/
   pf = &(files[curFile].lineInfo[myline].attachedFcalls[myNumOfFuncs]);
   pf->params     = (char **)malloc(sizeof(char *)*pcnt);
   pf->parIndices = (int *)malloc(sizeof(int)*pcnt);
    
   /* Set number of parameters */
   pf->numOfParams = pcnt;
   /* keep the function call string as string */
   pf->fcallString = (char *)malloc(strlen(fcallString)+1);
   pf->fname       = (char *)malloc(strlen(funcName)+1);
   strcpy(pf->fcallString,fcallString);
   strcpy(pf->fname,funcName);

   /* If SCIVIS function, store windowname */
   if (strstr(pf->fname,"java_")){
     startLoop = 1;
     pf->params[0] = (char *)malloc(strlen(params[0])+1);
     strcpy(pf->params[0],params[0]);
   }
   else
     startLoop = 0;

   if (DEBUG) 
     fprintf(fpout,"number of parameters : %d\n",pcnt);
   
   for(i=startLoop;i<pcnt;i++){
     index = find_var(curFuncName,params[i]);
     
     if (index< 0)
       printf("I could not find the variable : -%s-\n",params[i]);
     else if (stack[index].isDistributed)
       index = stack[index].localIndex;

     pf->params[i] = (char *)malloc(strlen(params[i])+1);
     strcpy(pf-> params[i],params[i]);  
     pf-> parIndices[i] = index;
     if (DEBUG) 
       fprintf(fpout,"I added the parameter : %s\n",pf-> params[i]);    
   }
   
   /*** increase the number of attached fcalls for this line ***/
   (files[curFile].lineInfo[myline].numOfAttachedFcalls)++;
   if (DEBUG) 
     fprintf(fpout,"I attached the Fcall string :%s  to line : %d\n",
	     pf->fcallString,myline);

   /* Store how many action points we attached to executable lines */
   numberOfActionPoints++;
   return (myNumOfFuncs);
   
}   


void send_profile_data(int managerSock) 
{
   int lineNum,numOfFiles = nfiles; 
   int k,j,funcIndex,stmtID,nexecution;
   double elapsed_time;
   char *buffer,*tsbuf,*ts,*funcName;
   XDR xdrs;
   int i,fsize,len,temp;

   if (!(((HOST)&&(applicationType == SIMD))||
                  (applicationType == MIMD)))
        return;

   tsbuf = (char *)malloc(2048);
   buffer = (char *)malloc(REGBUFSIZE);
   xdrmem_create(&xdrs,buffer,REGBUFSIZE,XDR_ENCODE);

   /* first pack ack. message before actual data */
   ts = make_errmsg("OK",curLineNum); 
   pack_nondebug_ack(curLineNum,GET_PROFILE_DATA ,0,ts,&xdrs);

   xdr_int(&xdrs,&numOfFiles);
   for(k=0;k<numOfFiles;k++){
     fsize = files[k].fileSize;
     for(j=0;j<fsize;j++){
       lineNum      = files[k].lineInfo[j].lineNum;
       funcIndex    = files[k].lineInfo[j].funcIndex;
       funcName     = files[k].functab[funcIndex].funcName;
       stmtID       = files[k].lineInfo[j].stmtID;
       nexecution   = files[k].lineInfo[j].nexecution;
       elapsed_time = files[k].lineInfo[j].elapsed_time;

       if (!(files[k].lineInfo[j].isExecutable))
	 continue;

       temp = -1;
       xdr_int(&xdrs,&temp);
       xdr_int(&xdrs,&lineNum);
       xdr_string(&xdrs,&funcName,strlen(funcName));
       xdr_int(&xdrs,&stmtID);
       xdr_int(&xdrs,&nexecution);
       xdr_double(&xdrs,&elapsed_time);
     }
     temp = -2;
     xdr_int(&xdrs,&temp);
   }

   /*first send the ack. command tag to the manager */
   send_int(managerSock,ACKCOMMAND);

   /*And send the total message length */
   len = xdr_getpos(&xdrs);
   send_int(managerSock,len);

   /*Send actual packaged data */
   send_raw_data(managerSock,buffer,len);
  
   /* xdr_destroy(&xdrs); */
   free(buffer);
   free(tsbuf);
   free(ts);

}  


int isItSameFunction(char *newFname,char *newParams[],
		     int nparams,AFCALLS *pf)
{
   int i,foundFlag;

   /* Is it same function name */
   if (strcasecmp(newFname,pf->fname))
     return 0;
   /* Does it has same number of parameters */
   if (nparams != (pf->numOfParams))
     return 0;
   for(i=0,foundFlag=1;i<nparams;i++)
     if (strcasecmp(newParams[i],pf->params[i])){
       foundFlag = 0;
       break;
     }
   
   return foundFlag;
}


void interpretHPFStmt(char *funcName)
{
   int  retval,cnt;
   char buf[REGBUFSIZE],sp[REGBUFSIZE];
   FILE *fp;
   ERRBUF errbuf;
   char receivedHPFList[REGBUFSIZE],*userDir,errmsgfile[MAXVARLEN];

   retval = callFuncDynamic(funcName,receivedHPFList,&errbuf);

   /* If applicationType is SIMD,then only HOST(proc_0) will send ack.
      If applicationType is MIMD,then each processor which got client command
      will send ack. */
   if (!(((HOST)&&(applicationType == SIMD))||
                  (applicationType == MIMD)))
     return;
   
   userDir = getenv("USERDIR"); 
   sprintf(errmsgfile,"%serrout",userDir);
   
    /* send OK. ack. code */
   if (retval == 0){
      sprintf(buf,"HPF Stmts were interpreted succesfully:%s",receivedHPFList);
      send_nondebug_err_ack(INTERPRET,retval,buf,curLineNum);
      return;
   }
   
   /* send runtime error */
   else if (errbuf.type == RUNTIME_ERROR){
      sprintf(buf,"Runtime Error:%s \n for HPF stmts :\n %s",
	     strsignal(errbuf.status) ,receivedHPFList);
      send_nondebug_err_ack(INTERPRET,RUNTIME_ERROR,buf,
                      curLineNum);
   }
   /* send compile time error */
   else if (errbuf.type == COMPILE_ERROR){
      printf("COMPILE_ERROR ..\n");
      sprintf(sp,"Syntax Error for %s\n",receivedHPFList);
      /* send the pghpf compiler output for syntax errors */
      fp = fopen(errmsgfile,"r");
      if (fp == NULL)
	printf("I can not open ERROR FILE !!! : %s\n",errmsgfile);
      
      while(!feof(fp)){
        fgets(buf,256,fp);
        strcat(sp,buf);
      }
      fclose(fp);
      /* send compilation error at once */
      send_nondebug_err_ack(INTERPRET,COMPILE_ERROR,sp,curLineNum);
   }
}

long  filelength(char *fileName)
{
  FILE *fp;
  long beg_ptr,end_ptr;
  
  fp = fopen(fileName,"r");
  beg_ptr = fseek(fp,0L,SEEK_SET);
  end_ptr = fseek(fp,0L,SEEK_END);
  fclose(fp);
  return (end_ptr-end_ptr+1);
}



int itemAddr(int ndims,int *coor,int *dims,long *lb)
{
   int i,j,k,m;
   int a ;

   for(j=1,a=coor[0]-lb[0];j<ndims;j++){
     for(k=0,m=coor[j]-lb[j];k<j;k++)
       m *= dims[k];
     a += m;
   }
   return a;
}

void interrupt_prog(int sig)
{
  char ebuf[1024];

  fprintf(fpout,"ME:%d I have catched one signal : %d \n",ME,sig);
  stop_program(ManagerSock,1);
  sprintf(ebuf,"%d :%s at line :%d \n",sig,strsignal(sig),curLineNum);
}


void set_signal_handler(handler)
void (*handler)(); 
{
 sigset_t new;
 struct sigaction act;

 sigfillset(&new);
 pthread_sigmask(SIG_UNBLOCK, &new, NULL);
 act.sa_handler = handler;
 act.sa_flags   = 0;
 
 sigaction(SIGHUP, &act, NULL); 
 sigaction(SIGINT, &act, NULL);   
 sigaction(SIGQUIT, &act, NULL);  
 sigaction(SIGILL, &act, NULL);   
 sigaction(SIGTRAP, &act, NULL);  
 sigaction(SIGIOT, &act, NULL);   
 sigaction(SIGABRT, &act, NULL);  
 sigaction(SIGEMT, &act, NULL);   
 sigaction(SIGFPE, &act, NULL);   
 sigaction(SIGKILL, &act, NULL);  
 sigaction(SIGBUS, &act, NULL);   
 sigaction(SIGSEGV, &act, NULL);  
 sigaction(SIGSYS , &act, NULL); 
 sigaction(SIGPIPE, &act, NULL); 
 sigaction(SIGALRM, &act, NULL);  
 sigaction(SIGTERM, &act, NULL);  
 sigaction(SIGUSR1, &act, NULL);  
 sigaction(SIGUSR2, &act, NULL);  
 sigaction(SIGCLD, &act, NULL);   
 sigaction(SIGCHLD, &act, NULL);  
 sigaction(SIGPWR, &act, NULL);   
 sigaction(SIGWINCH, &act, NULL); 
 sigaction(SIGURG, &act, NULL);   
 sigaction(SIGPOLL, &act, NULL);  
 sigaction(SIGIO, &act, NULL);    
 sigaction(SIGSTOP, &act, NULL);  
 sigaction(SIGTSTP, &act, NULL);  
 sigaction(SIGCONT, &act, NULL);  
 sigaction(SIGTTIN, &act, NULL);  
 sigaction(SIGTTOU, &act, NULL);  
 sigaction(SIGVTALRM, &act, NULL);  
 sigaction(SIGPROF, &act, NULL);  
 sigaction(SIGXCPU, &act, NULL);  
 sigaction(SIGXFSZ, &act, NULL);  
 sigaction(SIGWAITING, &act, NULL);  
 sigaction(SIGLWP, &act, NULL);   
 sigaction(SIGFREEZE, &act, NULL);  
 sigaction(SIGTHAW, &act, NULL);  
 sigaction(SIGCANCEL, &act, NULL); 
  
}

void arraysec_thread(myline,managerSock,funcName)
int myline,managerSock;
char *funcName;
{
    pthread_t	tid;
    int n;
    sigset_t new;
    PARAMBUF parbuf;
    
    parbuf.myline =  myline ; 
    parbuf.managerSock = managerSock ;
    parbuf.funcName = funcName ;
   
    sigfillset(&new);
    pthread_sigmask(SIG_UNBLOCK, &new, NULL);
    if ( n = pthread_create( &tid, NULL, sendArraySection, (void *)(&parbuf) ) ) {
	fprintf( stderr, "pthread_create: %s\n", strerror( n ) );
	exit( 1 );
    }

    if ( n = pthread_join( tid, NULL ) ) {
	fprintf( stderr, "pthread_join: %s\n", strerror( n ) );
	exit( 1 );
    }
   
}


void interrupt_arraysec(int sig)
{
   char ebuf[1024];

   if (curCmnd != DISARRAYSECTION)
     interrupt_prog(sig);
   
   fprintf(fpout,"interrupt_arraysec: I catched signal :%d ME=%d\n",sig,ME);
   
   if (!HOST){
      pthread_exit( 0 ); 
      return;
   }

   sprintf(ebuf,"Array section error : %d :%s at line :%d \n",
	  sig,strsignal(sig),curLineNum);
   send_int(last_sockfd,ARRAYSECERROR);
   send_String(last_sockfd,ebuf);
   pthread_exit( 0 ); 
}  

void *sendArraySection(void *parbuf_) 
{
     PARAMBUF *parbuf;
     int myline,sockfd;
     char *funcName;
     sigset_t oset;

     char variableName[256],*array_expr,msg[256];
     int nums,nbytes,i,j,k,vindex,*subs;
     int slb[7],sub[7],sst[7],elsize;
     long *lb,*ub;
     int coor[7],cnt,id,totelems,ndims,index,type;
     static char *sendbuf;
     static char *buf,*buf_t;
     int managerSock ;
     
     
     XDR xdrs;
     bool_t ret;
     
     /* set signal header */
     set_signal_handler(interrupt_arraysec); 

     funcCallStatus = 0;
     parbuf = (PARAMBUF *)parbuf_;
     myline = parbuf->myline ;
     managerSock = parbuf->managerSock;
     funcName = parbuf->funcName ;
    
     array_expr = (char *)malloc(256);
     recv_String(managerSock,array_expr);
     recv_String(managerSock,variableName);
     recv_int(managerSock,&nums);
     nbytes = nums*sizeof(int);
     buf  = (char *)malloc(nbytes);
     subs = (int *)malloc(nbytes);
     recv_raw_data(managerSock, buf, nbytes);
     xdrmem_create(&xdrs,buf,nbytes,XDR_DECODE); 
     ret = xdr_vector(&xdrs,(char *)subs,nums,sizeof(int),xdr_int);
     /* xdr_destroy(&xdrs); */
     if (ret == FALSE){
	fprintf(fpout,"There is encoding error \n");
	if (DEBUG)
	   fprintf(fpout,"There is encoding error \n");
     }
	        
     vindex = find_var(funcName,variableName);
     if (vindex < 0){
         sprintf(msg,"We could not find the variable : %s",variableName);
	 send_nondebug_err_ack(curCmnd,-5,msg,myline);
     }
        
     if (vindex < 0){
        pthread_exit( 0 ); 
        return;
     }

     if (!(stack[vindex].isDistributed ))
       id = vindex;
     else{
       copy_from_parallel_to_serial(vindex);
       id = stack[vindex].localIndex;
     }

     /*if (!HOST ){
       pthread_exit( 0 ); 
       return;
     } */

     type = stack[id].type;     
     ndims = stack[id].ndims;
     lb = stack[id].lbounds;
     ub = stack[id].ubounds;

     	   
     for(i=0,k=0;k<ndims;k++)
     {       
       if (subs[i] == 1){ /* one element*/
	 slb[k] = subs[i+1];
         sub[k] = slb[k];
         sst[k] = 1;
         i+=2;
	 fprintf(fpout,"one element %d:%d:%d \n", slb[k],sub[k],sst[k]);
	 
       }    
       else if (subs[i] == 2){ /* section with no stride*/
         slb[k] = subs[i+1];
         sub[k] = subs[i+2];
	 sst[k] = 1;
         if (subs[i+1] == NUSEDDIM )
	   slb[k] = lb[k];
         if (subs[i+2] == NUSEDDIM )
	   sub[k] = ub[k];
         i+=3;
         fprintf(fpout,"section with no stride \n");
	 
       }

       else if (subs[i] == 3){ /* section with  stride*/
	 slb[k] = subs[i+1];
         sub[k] = subs[i+2];
	 sst[k] = subs[i+3];
         if (subs[i+1] == NUSEDDIM )
	   slb[k] = lb[k];
         if (subs[i+2] == NUSEDDIM )
	   sub[k] = ub[k];
	 if (subs[i+3] == NUSEDDIM )
	   sst[k] = 1;
	 i+=4;
	 fprintf(fpout,"section with  stride \n");
	 
       }
     }
 
     elsize = stack[id].elsize;
     for(k=0,totelems=1;k<ndims;k++)
       totelems *= ((sub[k]-slb[k])/sst[k]+1);
     sendbuf = (char *)malloc(elsize*totelems);
     for(k=0;k<ndims;k++) 
       coor[k] = slb[k];
    
     for(k=0;k<totelems;k++){
      index = itemAddr(ndims,coor,stack[id].dim_info,lb);
       
      memcpy(&sendbuf[k*elsize],((char *)(stack[id].buf)+index*elsize),elsize);
      
      coor[0] += sst[0];
      if (coor[0] > sub[0])
	 coor[0] = slb[0];
      for(j=1;j<ndims;j++){
	 if (coor[j-1] == slb[j-1]){
	   coor[j] += sst[j];
	   if (coor[j] > sub[j])
	     coor[j] = slb[j];
	 }
      }
     }
     
     pack_and_send_arraySec(vindex,array_expr,variableName,elsize,type,
            totelems,sendbuf,ManagerSock);
     pthread_exit( 0 );  
}      

void pack_and_send_arraySec(int id,char *variableName,char *array_expr,
      int elsize,int type,int totelems,char *sendbuf,int managerSock)
{
   char *buffer,*ts;
   XDR xdrs;
   int len;
   
   buffer = (char *)malloc(REGBUFSIZE);
   xdrmem_create(&xdrs,buffer,REGBUFSIZE,XDR_ENCODE);

   /* WARNING !!! access to shared item,myline */
   /* first pack ack. message before actual data */
   ts = make_errmsg("OK",curLineNum); 
   pack_nondebug_ack(curLineNum,DISARRAYSECTION,0,ts,&xdrs);
   /* pack distribution info */
   xdr_int(&xdrs,&(stack[id].isDistributed));
   /* pack array expression */
   xdr_string(&xdrs,&array_expr,strlen(array_expr));
   /* Pack registration information */
   pack_registration_info_(0,variableName,type,1,totelems, &totelems,&xdrs); 

   /* pack actual array section */
   putArraySection(&xdrs,sendbuf,totelems,elsize,type);

   /* first send the ack. command tag to the manager */
   send_int(managerSock,ACKCOMMAND);

   /* And send the total message length */
   len = xdr_getpos(&xdrs);
   send_int(managerSock,len);

   /* Send actual packaged data */
   send_raw_data(managerSock,buffer,len);
  
   /* xdr_destroy(&xdrs); */
   free(buffer);
   free(ts);
   free(array_expr);
   
}


void putArraySection(XDR *xdrs,char *sendbuf,int nelems,int elsize,int type)
{

  bool_t ret;

  switch(type){
    case T_CHAR  : 
      ret = xdr_vector(xdrs,sendbuf,nelems,elsize,xdr_char);
      break;
    case T_INT   : 
      ret = xdr_vector(xdrs,sendbuf,nelems,elsize,xdr_int);
      break;
    case T_FLOAT : 
      ret = xdr_vector(xdrs,sendbuf,nelems,elsize,xdr_float);
      break;
    case T_LONG  :
      ret = xdr_vector(xdrs,sendbuf,nelems,elsize,xdr_long);
      break;
    case T_DOUBLE:
      ret = xdr_vector(xdrs,sendbuf,nelems,elsize,xdr_double);
      break;  
  }
  if (ret == FALSE)
     fprintf(fpout,"there is error during encoding (in putArraySection) \n");

}

