#include "deftypes.h" 
   
extern FILES *files;
extern FTAB  *functab;
extern int   nfuncs,nfiles;
extern int   curFile;     /* currrent file index which was read before */
extern int   indexOfMain; /* file index which contais main program */
extern int   *filesSent;

extern char    hpf_portnum[64],manager_portnum[64],manager_host[128];
extern int     max_push_id;

/* Use the registrated variable "sock_recv_bits " as temporary to
   copy the select events to other processors */

extern DATA  stack[MAX_VARS];
extern CONTROLSTACK cstack;
extern int   errno;
extern char  *sys_errlist[];

/* server global variables */
extern int curCmnd,deb_curCmnd,targetPid ,goToCursorLine;
extern int nIterStartLine,loopHeaderLine,curCounter;
extern int is_staying_in_server;
extern char *curFileName ,*prevFileName;
extern char *curFuncName ,*prevFuncName;
extern int  prevStackTop;

  
extern FILE *fpout;    
extern char projectName[256];  
extern char receivedHPFList[REGBUFSIZE];
extern int last_sockfd; /* keeping for signal handler */
extern int curLineNum,prevLineNum ;

extern int  funcCallStatus; 
extern int  nextModule;
extern int  stackLength ;   
extern char *mainFileName,*mainFuncName;
extern int  curFunction;
/* extern int  isJustStarted = 0; Is program just started? */

extern char SageServerPort[256],SageServerHost[256];
extern int  SageServerSock;
extern int  WebFlowSockfd;   
extern int  numberOfActionPoints,numberOfBreakPoints;
extern int  nclients;
extern int  applicationType; /* SIMDI/MIMD(1/2) */
extern char ManagerPort[256],ManagerHost[256];
extern int  ManagerSock;
extern pthread_t  control_thread_tid;

extern pthread_mutex_t   running_state_mutex;
extern pthread_cond_t    running_state_cond;
extern int               running_state; /* RUNNING,SUSPEND or STOPPED */ 
extern int isInsideDARPServer;


extern DQUEUE     *command_q_tail,*command_q_head;
extern pthread_mutex_t command_q_mutex;
extern pthread_cond_t  command_q_cond ;
/********************/
extern ACKQ              *ack_q_tail,*ack_q_head;
extern pthread_mutex_t   ack_q_mutex;

/*for timer purpose */
extern struct timeval start_gettimeofday;
extern clock_t ts_start;
extern clock_t server_acc,register_acc;
extern int server_ncalls;

  
void err(char *) ;
void configure_client_(int *,char *,int *);
int server (int ,char *,char *,DQUEUE);
int recv_int(int, int*);  
void send_int(int,int);
int findFileIndex(char *);
int GetInstrumentedCode(int nextModule,char *funcName,char *usedVars[],
			int *numOfVars,char *userHpfStmts);
int callFuncDynamic(char *curHpfFunc, char *userHpfStmts,ERRBUF *errbuf);
int calcIndices(char *curHpfFunc,char *usedVars[],int numOfusedVars,int *ind);
void fatal();
void interpretHPFStmt(char *funcName);
void interrupt_prog(int sig);
void interrupt_arraysec(int sig);
void  interrupt(int sig);
void *sendArraySection(void *parbuf_) ;
void arraysec_thread(int myline,int managerSock,char *funcName);
void set_signal_handler(void (*handler)());
int isItSameFunction(char *newFname,char *newParams[],
		     int nparams,AFCALLS *pf);
void *callToAttachedFuncs(void *parstruct);
void registerFcall(char *fcallString,int myline);
void send_scivizFlist(int sockfd);
void send_localVars(int sockfd,char *funcName);
void send_String (int sockfd,char *variableName);
int  processAction(char *fcallString,int myline,int findex);
void executeActionPoints(int myline,int nthf);
void send_profile_data(int sockfd);
int  init_hpf_server_(char *hpfserver_portnum,char *sageserver_host,
		      char *sageserver_portnum,  char *pName,
		      int *hpfargs,char *envs);
void register_var_(int *var_type, int *var_id, long var, char *name, 
int *var_ndims,char *funcName,int *in_attributes,int *isDist, ...);
int setjmp_(int *myline,char *fileName);
void findUsedVars(char *hpfStmtList,char *inputFile,char *funcName,
		  char *usedVars[],int *nVars);
int errexit(char *format, ...);
void send_errmsg(int errorcode,char *errormsg,int myline);
int find_var(char *funcName,char *name);
void free_vars(char *usedVars[],int nVars);
int  insertList(char *list[],int *len,char *key);
int isParamVar(int index);  
int symbAttributes(int index);
int isModuleVar(int index);
void XDR_data(int id,int XDR_flag,XDR  *xdrs);
void encode_send_data(int id,SBUF *sendbuf,int XDR_flag);
void send_data_(int id,int sockfd);
void decode_recv_data(int id,char *recvbuf,int datalen,int XDR_flag);
void mask_three_signals(sigset_t *oset);
void unmask_three_signals(sigset_t *oset);
void recv_data_(int id,int sockfd);
int recv_raw_data(int fd, char *buf, int nbytes);
void send_raw_data(int sockfd,char *buf,int len);
void send_registration_info_(int tag,char *variableName,int type,int ndims
			     ,int nelems,int *dims,int sockfd);
void sendrecv_string(char *buf,int sockfd,int XDR_FLAG);
int send_registered_data(char *variableName, int id, int sockfd);
void recvParseTree();
void c_distribute_string_();
void read_parse_tree_();
void hpf_server_(int *myline,char *funcName,char *fileName);
void distribute_sock_event(fd_set *rfds);
void recv_double(int sockfd,double *command);
void send_double(int sockfd,double command);
void recv_String (int sockfd,char *variableName);
void send_String (int sockfd,char *variableName);
void set_ParallelVar(int sockfd,int id);
void copy_from_parallel_to_serial(int id);
void copy_from_serial_to_parallel(int id);
void err(char *string);
void write_summary(char *outFile,int nfiles);
void executeFunctionCall(char *fcallString,char *extFuncName);
void stop_program(int sockfd,int AppletStop);
int amIinCurrentLoop(int myline,int currentLoopHeader);
int  send_function_params(int managerSock,int myline);
double  timer();
void send_action_points(int sockfd);
int isItSameFunction(char *newFname,char *newParams[],
		     int nparams,AFCALLS *pf);
int findFuncIndex(char *curFuncName,char *curFileName);
void sendFileIndex(char *curf,char *nextf);
int gotoStackUp();
int gotoStackDown();
void updateControlStack(int myline);
int itemAddr(int ndims,int *coor,int *dims,long *lb);
void putArraySection(XDR *xdrs,char *sendbuf,int nelems,int elsize,int type);
int yylex();
void read_Config_File(char *ConfigFile,int sockfd);
int connectsock(char *host, char *service, char *protocol);
void store_config(char *ConfigFile)  ;
void log_fprintf(FILE *fp,char *format,...);
int DoWeStopHere(int myline,char *funcName,char *fileName);
void distribute_array(int *array,int len);
void apply_Config_File(char *ConfigFile,int myline);
void readConfigAndSend(char *ext);
void distribute_bytes(char *buf,int len);
char *make_errmsg(char *errmsg,int myline);
void pack_nondebug_ack(int myline,int commandTag,int errcode,
		       char *errmsg,XDR *xdrs);
void pack_registration_info_(int tag,char *variableName,int type,int ndims
			     ,int nelems,int *dims,XDR *xdrs);
void send_nondebug_err_ack(int commandTag,int errcode,char *errmsg,int myline);
void send_multiple_Strings (char *variables[],char *extrastring,
			    int *extra_int_array,int nstrings);
void pack_and_send_action_points(int managerSock);
long  filelength(char *fileName);
void pack_and_send_arraySec(int id,char *variableName,char *array_expr,
    int elsize,int type,int totelems,char *sendbuf,int managerSock);
void pack_and_send_attach_action(int managerSock,int attach_line,
   int attach_command);
void just_send_XDR_data(char *buffer,XDR *xdrs);
void pack_send_multiple_Strings (char *variables[],char *extrastring,
		 int *extra_int_array,int nstrings,XDR *xdrs);
void *control_server(void *args);
void recvParseTree_from_manager();
void wakeup_DARP_client();
void wait_until_running();
void send_instrument_command(int subcommand,int nextModule,
	     char *funcName, char *hpfStmtList);
int isDataAvailable();
void process_debug_ack(char *errmsg,int errcode,int myline,int commandTag );



