subroutine compute_r(ampl,sigma,r)

real(KIND=8) ampl,sigma
real(KIND=8), dimension(:,:,:), intent(out) :: r

real(KIND=8), dimension(size(r,dim=1)):: x,y,z

!HPF$ PROCESSORS P(NUMBER_OF_PROCESSORS())
!HPF$ DISTRIBUTE *(*,BLOCK,*) ONTO *P :: r
  
!HPF$ DISTRIBUTE (BLOCK) :: y

integer asize,offset
integer i,j,k

asize=size(r,dim=1)
offset=asize/2 

forall(i=1:asize) x(i)=i*1.d0
forall(i=1:asize) y(i)=i*1.d0
forall(i=1:asize) z(i)=i*1.d0

forall(i=1:asize,j=1:asize,k=1:asize) &
  r(i,j,k)=ampl*sin(0.1d0*(x(i)+k))*   &
               exp(-((y(j)-offset)**2/sigma))*   &
               exp(-((z(k)-offset)**2/sigma))

end

subroutine delayit(n,resulti)
integer n
real(KIND=8) resulti
integer i
real(KIND=8) c1,c2,c3

c1=1.34d0
c2=2.34d0
c3=3.45d0

resulti=1.0d0
do i=1,n
  resulti=sqrt(i*c1+c2)/sqrt(i*c3-c1)+resulti
enddo
return
end
